
local myMod = ...

-- Apply building asset processor
--StoneGateV5:registerAssetProcessor("models/2_8_castle_tower20_maya.fbx", {
--	DataType = "BUILDING_ASSET_PROCESSOR"
--})

-- Create default minor decoration part registering function 
function registerDefaultMinorPart(_nameFbx, _nameAsset)
    myMod:registerAssetId("models/2_8_castle_tower20_maya.fbx/Prefab/Castle/Windows/" .. _nameFbx .. "Part", "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_PREFAB")

    myMod:register({
	DataType = "BUILDING_PART",
	Id = "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_PART",
	Name = "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_NAME",
	Description = "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_PREFAB",
		IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	}
    })

    myMod:registerPrefabComponent("models/2_8_castle_tower20_maya.fbx/Prefab/Castle/Windows/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the facades)
	BuildingZone = { 2, 2 }
    })
end

registerDefaultMinorPart("window1", "WINDOW_1", 1)
registerDefaultMinorPart("window2", "WINDOW_2", 1)
registerDefaultMinorPart("window3", "WINDOW_3", 1)
registerDefaultMinorPart("window4", "WINDOW_4", 1)
registerDefaultMinorPart("window5", "WINDOW_5", 1)

-- Create default minor decoration part registering function 
function registerDefaultMinorPart(_nameFbx, _nameAsset)
    myMod:registerAssetId("models/2_8_castle_tower20_maya.fbx/Prefab/Castle/Gates/" .. _nameFbx .. "Part", "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_PREFAB")

    myMod:register({
	DataType = "BUILDING_PART",
	Id = "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_PART",
	Name = "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_NAME",
	Description = "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "CASTLE_BIG_DECORATION_" .. _nameAsset .. "_PREFAB",
		IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 4 }
		}
	}
    })

    myMod:registerPrefabComponent("models/2_8_castle_tower20_maya.fbx/Prefab/Castle/Gates/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the facades)
	--BuildingZone = { 2, 2 }
    })
end

registerDefaultMinorPart("gate1", "GATE_1", 1)
--registerDefaultMinorPart("PFenetre", "PFENETRE", 1)
--registerDefaultMinorPart("ArrowSlit", "ARROWSLIT", 1)
--registerDefaultMinorPart("Balcony", "BALCONY", 2)
--[[
-- Create default door decoration part registering function 
function registerDefaultDoorDecorationPart(_nameFbx, _nameAsset, _stoneCost)
    StoneGateV5:registerAssetId("models/decorations/decoration.fbx/Prefab/decoration/Entrance/" .. _nameFbx .. "Part", "STONE_GATE_V5_ENTRANCE_" .. _nameAsset .. "_PREFAB")

    StoneGateV5:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_ENTRANCE_" .. _nameAsset .. "_PART",
	Name = "STONE_GATE_V5_ENTRANCE_" .. _nameAsset .. "_NAME",
	Description = "STONE_GATE_V5_ENTRANCE_" .. _nameAsset .. "_DESC",
	Category = "DOOR",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V5_ENTRANCE_" .. _nameAsset .. "_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = _stoneCost }
		}
	}
    })

-- Register grounding components
    StoneGateV5:registerPrefabComponent("models/decorations/decoration.fbx/Prefab/decoration/Entrance/" .. _nameFbx .. "Part", {
	DataType = "COMP_GROUNDED"
    })

    StoneGateV5:registerPrefabComponent("models/decorations/decoration.fbx/Prefab/decoration/Entrance/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "DOOR", -- Allows the door to be used as entrance
	HasBuildingZone = true,
	BuildingZone = { 1, 1 }
    })
end

registerDefaultDoorDecorationPart("DoorA", "DOOR_A", 1)
registerDefaultDoorDecorationPart("DoorB", "DOOR_B", 1)]]
