local myMod = ...

-- Apply building asset processor
myMod:registerAssetProcessor("models/castle_tower6_maya.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/2_8_castle_tower20_maya.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register all monument building parts and their properties
myMod:dofile("scripts/building_parts.lua")

-- Register all monument decoration parts and their properties
myMod:dofile("scripts/decoration.lua")

-- Register the monument
myMod:register({
	DataType = "MONUMENT",
	Id = "CASTLE_BIG",
	Name = "CASTLE_BIG_NAME",
	Description = "CASTLE_BIG_DESC",
	BuildingType = "MONUMENT",
	BuildingPartSetList = {
		{ Name = "CASTLE_BIG_CORE",
		BuildingPartList = {
			"CASTLE_BIG_TOWER_A_ROOT_PART",
			"CASTLE_BIG_TOWER_B_ROOT_PART",
			"CASTLE_BIG_TOWER_C_ROOT_PART",
			"CASTLE_BIG_TOWER_D_ROOT_PART",
			"CASTLE_BIG_TOWER_F_ROOT_PART",
			"CASTLE_BIG_TOWER_G_ROOT_PART",
			"CASTLE_BIG_TOWER_H_ROOT_PART",
			"CASTLE_BIG_TOWER_I_ROOT_PART",
			"CASTLE_BIG_TOWER_J_ROOT_PART",
			"CASTLE_BIG_TOWER_J2_ROOT_PART",
			"CASTLE_BIG_TOWER_K_ROOT_PART",
			"CASTLE_BIG_TOWER_K2_ROOT_PART",
			"CASTLE_BIG_TOWER_L_ROOT_PART"}
		},
		{ Name = "CASTLE_BIG_EXTENSION",
		BuildingPartList = {
			"CASTLE_BIG_TOWER_E_ROOT_PART"}
		},
		{ Name = "CASTLE_BIG_ENTRANCE",
		BuildingPartList = {
			"CASTLE_BIG_DOOR_A_PART"}
		},
		{ Name = "CASTLE_BIG_WALL",
		BuildingPartList = {
			"CASTLE_BIG_WALL_A_ROOT_PART",
			"CASTLE_BIG_GATE_A_ROOT_PART",
			"CASTLE_BIG_BATTLEMENT_A_ROOT_PART"}
		},
		{ Name = "CASTLE_BIG_DECORATION",
		BuildingPartList = {
			"CASTLE_BIG_DECORATION_WOODENRAMPART_A_PART",
			"CASTLE_BIG_DECORATION_WINDOW_1_PART",
			"CASTLE_BIG_DECORATION_WINDOW_2_PART",
			"CASTLE_BIG_DECORATION_WINDOW_3_PART",
			"CASTLE_BIG_DECORATION_WINDOW_4_PART",
			"CASTLE_BIG_DECORATION_WINDOW_5_PART",
			"CASTLE_BIG_DECORATION_GATE_1_PART"}
		}
	},
	RequiredPartList = {
		-- Necessarily a list of 'MONUMENT_REQUIRED_PART_PAIR', no need to specify the DataType of each element of the list
		{ Category = "CORE", Quantity = 1 }--,
		--{ Category = "EXTENSION", Quantity = 2 },
		--{ Category = "DOOR", Quantity = 1 }
	},
	IsManuallyUnlocked = true,
	IsDestructible = true,
	IsEditable = true,
	IsClearTrees = true
})

myMod:register({
	DataType = "UNLOCKABLE_BUILDING",
	Id = "UNLOCKABLE_CASTLE_BIG",
	Name = "UNLOCKABLE_CASTLE_BIG_NAME",
	Description = "UNLOCKABLE_CASTLE_BIG_DESC",
	EstateInfluenceCostList = {
		{ Estate = "KINGDOM", Quantity = 1 }
	},
	RelatedProp = "CASTLE_BIG"
})